/*
 *
 *  Created on: 18/10/2016
 *      Author: rescue
 */

#ifndef CROSBOT_EXPLORE_ACTION_PARAMETERS_HPP_
#define CROSBOT_EXPLORE_ACTION_PARAMETERS_HPP_

#include <string>

namespace crosbot_explore {

/**
 * Exploration modes for crosbot explorer - placed in header files to allow extensible modes
 * which cannot be achieved through the explore.action class
 */
class ExploreMode {
public:
    enum {
        MODE_STOP = 0,
        MODE_RESUME = 1,
        MODE_LEFT_WALL = 2,
        MODE_RIGHT_WALL = 3,
        MODE_WAYPOINT = 4
    };
};

/**
 * Common exploration status feedback for crosbot explorer - placed in header files to allow extensible status messages
 * which cannot be achieved through the explore.action class
 */
class ExploreStatus {
public:
    static const std::string STATUS_ARRIVED;
    static const std::string STATUS_BLOCKED;
    static const std::string STATUS_PAUSED;
    static const std::string STATUS_RUNNNING;
};

} // namespace crosbot_explore


#endif /* CROSBOT_EXPLORE_ACTION_PARAMETERS_HPP_ */
