/*
 * colour4f.hpp
 *
 *  Created on: 17/08/2016
 *      Author: rescue
 */

#ifndef CROSBOT_MAP_GEOTIFF_COLOUR4F_HPP_
#define CROSBOT_MAP_GEOTIFF_COLOUR4F_HPP_

#include <crosbot/data/colour.hpp>

namespace crosbot_map_geotiff {

struct Colour4f {
public:
    float r,g,b,a;

    Colour4f() : r(0), g(0), b(0), a(1) {}
    Colour4f(float r, float g, float b, float a = 1.0) : r(r),g(g),b(b),a(a) {}
    Colour4f(const crosbot::Colour&c) : r(c.r/255.0), g(c.g/255.0), b(c.b/255.0), a(c.a/255.0) {}

    Colour4f& operator=(const crosbot::Colour& c) {
        r = (c.r/255.0);
        g = (c.g/255.0);
        b = (c.b/255.0);
        a = (c.a/255.0);

        return *this;
    }
};

} // namespace crosbot_map_geotiff

#endif /* CROSBOT_MAP_GEOTIFF_COLOUR4F_HPP_ */
