/*
 * Node for running the trial-and-error learner
 *
 *  Created on: 05/04/2014
 *      Author: qual_planning
 */

#include <ros/ros.h>

#include <crosbot_map_geotiff/geotiff.hpp>

#include <cstdio>
#include <cstdlib>
#include <QtGui/QApplication>

#define LOG_START    "CrosbotGeotiffNode ::"

namespace crosbot_map_geotiff {

int main_crosbot_map_geotiff(int argc, char** argv) {
    ros::init(argc, argv, "timothyw_comp3431");

    // Initialise QtGUI
    QApplication app( argc, argv );

    // Node Handle - Use '~' when loading config parameters
    // Use without '~' when publish/subscribe/service
    ros::NodeHandle nh("~");

    CrosbotGeotiffPtr crosbotGeotiff = new CrosbotGeotiff();
    crosbotGeotiff->configure();
    crosbotGeotiff->start();

    while (ros::ok()) {
        ROS_INFO("%s Spinning", LOG_START);

        ros::spin();
    }

    // Disconnect
    crosbotGeotiff->stop();

    return 0;
}

} // namespace crosbot_map_geotiff

// Actual main method outside of namespace
int main(int argc, char** argv) {
    crosbot_map_geotiff::main_crosbot_map_geotiff(argc, argv);
}
